/* Gauss_elimination.c */
#include "csc.h"

double Gauss_elimination(M, Ny, A, x)
   int M, Ny; double A[], x[];
   /* A(i,j) = A[i*Ny+j] (i = 0,1,...,M-1; j=0,1,...,M-1) */ 

{
   int	i, j, k; double p, q, aamax, aa, xx, min_pivot;

   min_pivot = 1.0e50; /* min_pivot ν */

   /* ʾõΤϤޤ */
   for (k = 0; k < M - 1; k++) {

      /* pivot Ԥ */
      i = k; aamax = fabs(A[k*Ny+k]);
      for (j = k; j < M; j++)
	 if (fabs(A[j*Ny+k]) > aamax)
	 { i = j; aamax = fabs(A[j*Ny+k]); }

      /* Ԥθ */
      if (i != k) {
	 for (j = k; j < M; j++)
	 { aa = A[k*Ny+j]; A[k*Ny+j] = A[i*Ny+j]; A[i*Ny+j] = aa; }
	 xx = x[k]; x[k] = x[i]; x[i] = xx;
      }

      /* min_pivot ι */
      p = A[k*Ny+k];
      if (fabs(p) < min_pivot) min_pivot = fabs(p);

      /* pivot Ԥ p ǳ */
      for (j = k + 1; j < M; j++) A[k*Ny+j] = A[k*Ny+j]/p;
      x[k] = x[k]/p;

      /* ʾõΣƥå */
      for (i = k + 1; i < M; i++) {
	 q = A[i*Ny+k]; x[i] = x[i] - q*x[k];
	 for (j = k + 1; j < M; j++) A[i*Ny+j] = A[i*Ny+j] - q*A[k*Ny+j];
      } 
   }
   /* ʾõΤ */

   /* ΤϤޤ */
   x[M-1] = x[M-1]/A[(M-1)*Ny+(M-1)];
   for (k=M-2; k>=0; k--)
      for (j=k+1; j<M; j++) x[k] = x[k] - A[k*Ny+j]*x[j];
   /* Τ */

   return min_pivot;
}
