/* LUdecomp.c */
#include "csc.h"

void LUdecomp(M, A, B, C)
    int M; double A[], B[], C[];
/*   LU-decomposition of a tri-diagonal matrix K
     гѹ K  K = LU ȣ̣ʬ
       K[i,i]   = A[i]  (i=0,...,M-1)
       K[i,i+1] = B[i]  (i=0,...,M-2)
       K[i,i-1] = C[i]  (i=1,...,M-1)
       L[i,i]   = 1     (i=0,...,M-1)
       L[i,i-1] = -C[i] (i=1,...,M-1)
       U[i,i]   = A[i]  (i=0,...,M-1)
       U[i,i+1] = B[i]  (i=0,...,M-2)        */
{
    int j;
    for (j = 1; j <= M - 1; j++)
    {  C[j] = -C[j]/A[j-1]; A[j] = A[j] + C[j]*B[j-1]; }
}
