/* cssmp52.c */
/* Finite Difference Method for Heat Equation ۲ˡ*/
/* Dirichlet 0 boundary condition */
#include "eagle.h" /* եå饤֥Υإåե */
#define Mmax (403)
unsigned long black, blue;  /* ̾ */

/* ʬۤꤹؿ */
void initial_distribution(M, L, dx, u, Gumin, Gumax)
  int M; double L, dx, *Gumin, *Gumax; double u[];
{
  int i, mode;
  printf("mode = "); scanf("%d", &mode);
  for (i = 1; i < M; i++) u[i] = 1.0 - cos(2.0*mode*M_PI*i*dx/L);
  u[0] = 0.0; u[M] = 0.0;

  /*  Gumax, Gumin ϥեåΤΤ */
  *Gumax = 2.1; *Gumin = -0.1;

}

/* u(t.x) Υդؿ */
void display(M, L, u, Gumin, Gumax, lambda)
  int M; double L, Gumin, Gumax, lambda; double u[];
{  
  int i; double Umax; double xx[Mmax];

  /* ͤη׻ */
  Umax = u[0];
  for (i = 1; i <= M; i++) if (u[i] > Umax) Umax = u[i];

  for (i = 0; i <= M; i++) xx[i] = L/M*i;
  xx[M+1] = L; xx[M+2] = 0.0; u[M+1] = 0.0; u[M+2] = 0.0;
  w_clear();
  x_printf(20, 20, "lambda = %lf  Umax = %lg", lambda, Umax);
  m_box(0.0, Gumin, L, Gumax, 0); m_line(0.0, 0.0, L, 0.0);
  set_foreground(blue);
  m_polygon(M+3, xx, u, 15);
  set_line_width(3); 
  m_polygon(M+3, xx, u, 0);
  set_foreground(black); 
  set_line_width(1);
}

main()
{
  Window      w0;
  double      u_new[Mmax], u_old[Mmax];
  double      L, diff, lambda, dx, dt, time, Gumin, Gumax;
  int         wx, wy, M, i, j, k, kk, ndisp, disp_interval;
  extern void initial_distribution(), display();

  printf("Diffusion coefficient diff = "); /* Ȼ */
  scanf("%lf", &diff);
  printf("Size of interval L = ");         /* ֤Ĺ */
  scanf("%lf", &L);
  printf("Degree of freedom M < %d, M = ", Mmax-2); /* ͳ M  */
  scanf("%d", &M);
  printf("lambda = "); scanf("%lf", &lambda); /* lambda  */
  printf("disp_interval = ");                 /* սϴֳ֤ */
  scanf("%d", &disp_interval);

  dx = L/M; dt = lambda*dx*dx/diff;

  /* ʬۤλ */
  initial_distribution(M, L, dx, u_old, &Gumin, &Gumax); time = 0.0;
  u_new[0] = u_old[0]; u_new[M] = u_old[M]; 

  wx = 600; wy = 400;                /* ɥ礭λ */
  w0 = x_init(wx, wy, "Eagle_data"); /* ǽΥɥ w0 򳫤 */
  black = set_color(0, 0, 0);        /*  */
  blue = set_color(0, 0, 255);       /*  */

  /* ɸϤλ */
  m_trans_def(0.0, Gumin, L, Gumax, 20, 30, wx-40, wy-40);

  display(M, L, u_old, Gumin, Gumax, lambda); /* u(t.x) Υ */

  while (1) {
    printf("Input  0 for ndisp to exit\n");
    printf("      -1 for ndisp to change disp_interval\n");
    printf("      -2 for ndisp to change lambda\n");
    printf("Number of displays ndisp = "); scanf("%d", &ndisp);

    /* ndisp = 0 ʤ׻ */
    if (ndisp == 0) break;

    /* ndisp = -1 ʤ饰սϴֳ֤ѹ */
    if (ndisp == -1) {
       printf("Display interval disp_interval = ");
       scanf("%d", &disp_interval);
    }

    /* ndisp = -2 ʤ lambda ѹ */
    if (ndisp == -2) {
      printf("lambda  = "); scanf("%lf", &lambda);
      dt = lambda*dx*dx/diff;
    }

    /* ndisp ǻꤵ줿ΥսϤ򤹤뤿η׻򤹤 */
    for (k = 0; k < ndisp; k++) {
      for (kk = 0; kk < disp_interval; kk++) {
        /* ʬˡˤ׻۲ˡ */
        for (j = 1; j < M; j++)
	  u_new[j] = (1.0-2.0*lambda)*u_old[j]
	             + lambda*(u_old[j-1] + u_old[j+1]);
	for (j = 1; j < M; j++) u_old[j] = u_new[j];
        time = time + dt;
      }
      display(M, L, u_new, Gumin, Gumax, lambda);
    }
  }

  printf("Type 0 to exit "); scanf("%d", &j); /* λԤ */

  w_close(w0); /* ɥξõ */
  x_term();    /* եåνλ */
}











