/* cssmp82.c */
#include "eagle.h"
#define Mmax (201)
double  u_new[Mmax][Mmax], u_old[Mmax][Mmax];
unsigned long color_name[128];

void my_color_name(N)
  int N;
{
  int i, j;
  for (i = 0; i < N; i++) {
    j = i*256/N;
    color_name[    i] = set_color(0, j, 255);
    color_name[  N+i] = set_color(0, 255, 255-j);
    color_name[2*N+i] = set_color(j, 255, 0);
    color_name[3*N+i] = set_color(255, 255-j, 0);
  }
  for (i = 0; i < 4*N; i++) {
    set_foreground(color_name[i]); x_box(10, 390-3*i, 20, 3, 1);
  }
  x_printf(40, 20, "High");
  set_foreground(color_name[0]); x_printf(40, 390, "Low");
}

void display(Mx, My, N, umin, uwidth)
  int Mx, My, N; double umin, uwidth;
{  
  int i, j, k, px0, py0, dum; double ustep;
  ustep = uwidth/(N-0.000001); px0 = 10; py0 = 410;
  for (i = 1; i < Mx; i++) for (j = 1; j < My; j++) {
    k = (u_old[i][j]-umin)/ustep;
    if (k >= N) k = N-1;
    if (k <  0) k = 0;
    set_foreground(color_name[k]);
    x_box(px0+2*i, py0-2*j, 2, 2, 1);
  }
}

void initial_distribution(Mx, My, dx, dy, umin, umax, uwidth)
  int Mx, My; double dx, dy, *umin, *umax, *uwidth;
{
  int i, j;
  double x, y;
  *umax = 1.0; *umin = 0.0;
  for (i = 0; i <= Mx; i++) for (j = 0; j <= My; j++) u_old[i][j] = 0.0;
  for (i = 0; i <= Mx; i++) for (j = 0; j <= My; j++) {
    x = i*dx; y = j*dy;
    if ((x>29.5)&&(x<=30.5)&&(y>9.5)&&(y<=19.5)) u_old[i][j] = 1.05;
  }
  *uwidth = *umax - *umin;
}

main()
{
  Window w0, w1, w2;
  double Lx, Ly, diff, lamx, lamy, dx, dy, dt, dtmax, time, umin, umax, uwidth;
  int    wx, wy, Mx, My, i, j, k, kk, ndisp, disp_interval;
  int    color_base, color_number;
  extern void initial_distribution(), my_color_name(), display();

  diff = 1.0; Lx = 100.0; Ly = 100.0; Mx = 200; My =200;
  dx = Lx/My; dy = Ly/My; 
  dtmax = (dx*dx*dy*dy)/2.0/diff/(dx*dx+dy*dy);
  if (dtmax > 0.1) dtmax = 0.1;
  printf("dt <= %lg, dt = ", dtmax); scanf("%lf", &dt); 
  lamx = diff*dt/dx/dx; lamy = diff*dt/dy/dy;
  disp_interval = 10;

  initial_distribution(Mx, My, dx, dy, &umin, &umax, &uwidth);

  wx = 550; wy = 460;
  w0 = x_init(wx, wy, "Eagle_data");
  w1 = w_open(w0, 450, 10, 90, 400);
  w2 = w_open(w0, 10, 420, 530, 30);
  color_base = 32; color_number = 4*color_base;
  w_select(w1);
  my_color_name(color_base);
  w_select(w0);

  time = 0.0;
  w_select(w2); w_clear(); set_foreground(color_name[0]);
  x_printf(10, 20, "time = %lf", time);
  w_select(w0); display(Mx, My, color_number, umin, uwidth);

  while (1) {
     printf("Input  0 for ndisp to exit\n");
     printf("      -1 for ndisp to change disp_interval\n");
     printf("      -2 for ndisp to change dt\n");
     printf("Number of displays ndisp = "); 
     scanf("%d", &ndisp);
     if (ndisp == 0) break;
     if (ndisp == -1) {
        printf("Display interval disp_interval = ");
        scanf("%d", &disp_interval);
     }
     if (ndisp == -2) {
        printf("dt < %lg, dt = ", (dx*dx*dy*dy)/2.0/diff/(dx*dx+dy*dy));
        scanf("%lf", &dt); lamx = diff*dt/dx/dx; lamy = diff*dt/dy/dy;
     }

     for (k = 0; k < ndisp; k++) {
       for (kk = 0; kk < disp_interval; kk++) {
         for (i = 1; i < Mx; i++) {
             u_new[i][My] = ( (1.0-2.0*lamx-2.0*lamy)*u_old[i][My]
			      + lamx*(u_old[i-1][My]+u_old[i+1][My])
                              + lamy*(u_old[i][My-1]+u_old[i][1])
                              + dt*u_old[i][My] ) 
                            / (1.0 + dt*u_old[i][My]);
           u_new[i][ 0] = u_new[i][My];
	   for (j = 1; j < My; j++)
	       u_new[i][j] = ( (1.0-2.0*lamx-2.0*lamy)*u_old[i][j]
                               + lamx*(u_old[i-1][j]+u_old[i+1][j])
                               + lamy*(u_old[i][j-1]+u_old[i][j+1])
                               + dt*u_old[i][j] )
                             / (1.0 + dt*u_old[i][j]);
	 }
         for (j = 1; j < My; j++) {
             u_new[Mx][j] = ( (1.0-2.0*lamx-2.0*lamy)*u_old[Mx][j]
                              + lamx*(u_old[Mx-1][j]+u_old[1][j])
                              + lamy*(u_old[Mx][j-1]+u_old[Mx][j+1])
                              + dt*u_old[Mx][j] )
                            / (1.0 + dt*u_old[Mx][j]);
           u_new[ 0][j] = u_new[Mx][j];
         }
           u_new[Mx][My] = ( (1.0-2.0*lamx-2.0*lamy)*u_old[Mx][My]
                             + lamx*(u_old[Mx-1][My]+u_old[1][My])
                             + lamy*(u_old[Mx][My-1]+u_old[Mx][1])
                             + dt*u_old[Mx][My] )
                           / (1.0 + dt*u_old[Mx][My]);
         u_new[Mx][ 0] = u_new[Mx][My];
         u_new[ 0][My] = u_new[Mx][My];
         u_new[ 0][ 0] = u_new[Mx][My];
         for (i = 0; i <= Mx; i++) for (j = 0; j <= My; j++) 
	   u_old[i][j] = u_new[i][j];
	 time = time + dt;
       }
       w_select(w2); w_clear(); set_foreground(color_name[0]);
       x_printf(10, 20, "time = %lf", time);
       w_select(w0); display(Mx, My, color_number, umin, uwidth);
     }
  }

  printf("Type 0 to exit "); scanf("%d", &j);
  w_close(w1); w_close(w2); w_close(w0); x_term();
}


