/* eagle.h in ~/eagle */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <varargs.h>

typedef double X_real;

Display *display_eagle;
Window rw_eagle;
Window w_first_eagle;
Window w_present_eagle;
GC     gc_eagle;
unsigned long foreground_eagle, background_eagle;
Pixmap bitmap_eagle[10];
int line_style_eagle;
unsigned int line_width_eagle;
X_real Ax_eagle, Bx_eagle, Ay_eagle, By_eagle;
int    font_id_eagle;
int    p_control_eagle;
FILE   *file_id_eagle;

extern Window x_init(), w_open();
extern void x_term(), w_close(), w_clear(), w_select(), w_fill(),
	    w_clear_area();
extern void set_defaults(), set_foreground(), set_background(), 
	    set_line_width(), set_line_style(), set_fill_style(),
	    set_stipple_patterns(), set_font(), 
	    set_draw_mode(), set_cursor();
extern unsigned long set_color_name();
extern void x_point(), x_line(), x_box(), x_circle(), x_lines(),
	    x_polygon();
extern void m_trans_def(), m_trans_m_to_x(), m_trans_x_to_m(),
	    m_point(), m_line(), m_box(), m_circle(),
	    m_lines(), m_graph(), m_polygon(), m_hidden();
extern int  x_printf(), m_printf();
extern int  e_wait();
extern void e_mouse_state();
extern Bool e_nowait(), e_nowait_window();
