/* eagle1.c in ~/eagle */
#include "eagle.h"

Window x_init(x_width, y_height, file_name)
            int x_width, y_height; char *file_name;
{
            Window w; XEvent event;
/*( 1)*/    display_eagle = XOpenDisplay(NULL);
/*( 2)*/    rw_eagle = XDefaultRootWindow(display_eagle);
            x_width = abs(x_width); y_height = abs(y_height);
/*( 3)*/    w = XCreateSimpleWindow
		(display_eagle, rw_eagle, 0, 0, x_width, y_height, 2,
	         BlackPixel(display_eagle,0), WhitePixel(display_eagle,0));
/*( 4)*/    XSelectInput(display_eagle, w, ExposureMask | KeyPressMask |
	                 ButtonPressMask | ButtonReleaseMask |
                         PointerMotionMask | EnterWindowMask | LeaveWindowMask);
/*( 5)*/    XStoreName(display_eagle, w, "EAGLE");
/*( 5)*/    XSetIconName(display_eagle, w, "EAGLE");
/*( 6)*/    XMapWindow(display_eagle, w);
/*( 7)*/    do { XNextEvent(display_eagle, &event); } while(event.type!=Expose);
/*( 8)*/    set_cursor(w);
/*( 9)*/    XSetInputFocus(display_eagle, w, RevertToParent, CurrentTime);
/*(10)*/    set_defaults(w);
/*(11)*/    XFlush(display_eagle);
/*(12)*/    w_first_eagle = w;
/*(13)*/    file_id_eagle = fopen(file_name, "w");
/*(13)*/    fprintf(file_id_eagle, "x_init\n");
/*(13)*/    fprintf(file_id_eagle, "%d %d\n", x_width, y_height);
            return w;
}

Window w_open(w_parent, x, y, x_width, y_height)
    Window w_parent; int x, y, x_width, y_height;
{
    Window w; XEvent event;
    x_width = abs(x_width); y_height = abs(y_height);
    w = XCreateSimpleWindow(display_eagle, w_parent, x, y, x_width, y_height,
	2, BlackPixel(display_eagle,0), WhitePixel(display_eagle,0));
    XSelectInput(display_eagle, w,
	ExposureMask | KeyPressMask | ButtonPressMask | ButtonReleaseMask |
        PointerMotionMask | EnterWindowMask | LeaveWindowMask);
    XMapWindow(display_eagle, w);
    do { XNextEvent(display_eagle, &event); } while(event.type!=Expose);
    set_cursor(w);
    XFlush(display_eagle);
    return w;
}

void w_close(w)
    Window w;
{
    XDestroyWindow(display_eagle, w);
    XFlush(display_eagle);
}

void x_term()
{
    XCloseDisplay(display_eagle);
    fprintf(file_id_eagle, "x_term\n");
    fclose(file_id_eagle);
}

void w_select(w)
    Window w;
{
    w_present_eagle = w;
}

void w_clear()
{
    XClearWindow(display_eagle, w_present_eagle);
    XFlush(display_eagle);
    if( (w_present_eagle == w_first_eagle) && (p_control_eagle == 1) )
      fprintf(file_id_eagle, "w_clear\n");
}

void w_clear_area(x, y, x_width, y_height)
    int x, y, x_width, y_height;
{
    x_width = abs(x_width); y_height = abs(y_height);
    XClearArea(display_eagle, w_present_eagle, x, y, x_width, y_height, False);
    XFlush(display_eagle);
}

void w_fill(fp)
    int fp;
{
    Window root; int x, y;
    unsigned int x_width, y_height, border, depth;
    XClearWindow(display_eagle, w_present_eagle);
    if (fp > 9) {
      XGetGeometry(display_eagle, w_present_eagle, &root, &x, &y,
		   &x_width, &y_height, &border, &depth);
      x_box(0, 0, x_width, y_height, fp);
    }
    XFlush(display_eagle);
}
