/* eagle3.c in ~/eagle */
#include "eagle.h"

void x_point(x, y)
    int x, y;
{
    XDrawPoint(display_eagle, w_present_eagle, gc_eagle, x, y);
    XFlush(display_eagle);
    if( (w_present_eagle == w_first_eagle) && (p_control_eagle == 1) ) {
      fprintf(file_id_eagle, "x_point\n");
      fprintf(file_id_eagle, "%d %d\n", x, y);
    }
}

void x_line(x1, y1, x2, y2)
    int x1, y1, x2, y2;
{
    XDrawLine(display_eagle, w_present_eagle, gc_eagle, x1, y1, x2, y2);
    XFlush(display_eagle);
    if( (w_present_eagle == w_first_eagle) && (p_control_eagle == 1) ) {
      fprintf(file_id_eagle, "x_line\n");
      fprintf(file_id_eagle, "%d %d %d %d %d %d\n",
	      line_style_eagle, line_width_eagle, x1, y1, x2, y2);
    }
}

void x_box(x, y, x_width, y_height, fp)
    int x, y, x_width, y_height, fp;
{
    x_width = abs(x_width); y_height = abs(y_height);
    if (fp > 0) {
       set_fill_style(fp);
       XFillRectangle(display_eagle, w_present_eagle, gc_eagle, x, y,
		      x_width, y_height);
       set_fill_style(1);
    }
    else XDrawRectangle(display_eagle, w_present_eagle, gc_eagle, x, y,
		        x_width, y_height);
    XFlush(display_eagle);
    if( (w_present_eagle == w_first_eagle) && (p_control_eagle == 1) ) {
      fprintf(file_id_eagle, "x_box\n");
      fprintf(file_id_eagle, "%d %d %d %d %d %d %d\n",
	line_style_eagle, line_width_eagle, fp, x, y, x_width, y_height);
    }
}

void x_circle(x, y, a, b, fp)
    int x, y, a, b, fp;
{
    a = abs(a); b = abs(b);
    if (fp > 0) {
       set_fill_style(fp);
       XFillArc(display_eagle, w_present_eagle, gc_eagle, x-a, y-b,
			       2*a, 2*b, 0, 23040);
       set_fill_style(1);
    }
    else XDrawArc(display_eagle, w_present_eagle, gc_eagle, x-a, y-b,
				 2*a, 2*b, 0, 23040);
    XFlush(display_eagle);
    if( (w_present_eagle == w_first_eagle) && (p_control_eagle == 1) ) {
      fprintf(file_id_eagle, "x_circle\n"); b = (a + b)/2.0;
      fprintf(file_id_eagle, "%d %d %d %d %d %d\n",
	      line_style_eagle, line_width_eagle, fp, x, y, b);
    }
}

void x_lines(n, x, y)
    int n; int x[], y[];
{
    XPoint *points; int i;
    points = (XPoint *)malloc(sizeof(*points)*n);
    for (i=0; i<n; i++) { points[i].x = x[i]; points[i].y = y[i]; }
    XDrawLines(display_eagle, w_present_eagle, gc_eagle, points, n,
			      CoordModeOrigin);
    XFlush(display_eagle); free(points);
    if( (w_present_eagle == w_first_eagle) && (p_control_eagle == 1) ) {
      fprintf(file_id_eagle, "x_lines\n");
      fprintf(file_id_eagle, "%d %d %d\n",
			      n, line_style_eagle, line_width_eagle);
      for (i = 0; i < n; i++)  fprintf(file_id_eagle, "%d %d\n", x[i], y[i]);
    }
} 

void x_graph(n, x0, x1, y)
    int n, x0, x1; int y[];
{
    XPoint *points; int i;
    points = (XPoint *)malloc(sizeof(*points)*(n+1));
    for (i=0; i<=n; i++)
    { points[i].x = x0 + (x1-x0)*i/n; points[i].y = y[i]; }
    XDrawLines(display_eagle, w_present_eagle, gc_eagle, points, n+1,
	       CoordModeOrigin);
    XFlush(display_eagle); free(points);
    if( (w_present_eagle == w_first_eagle) && (p_control_eagle == 1) ) {
      fprintf(file_id_eagle, "x_graph\n");
      fprintf(file_id_eagle, "%d %d %d %d %d\n",
			      n, line_style_eagle, line_width_eagle, x0, x1);
      for (i = 0; i <= n; i++) fprintf(file_id_eagle, "%d\n", y[i]);
    }
}

void x_polygon(n, x, y, fp)
    int n, fp; int x[], y[];
{
    XPoint *points; int i;
    points = (XPoint *)malloc(sizeof(*points)*(n+1));
    for (i=0; i<n; i++) { points[i].x = x[i]; points[i].y = y[i]; }
    points[n].x = points[0].x; points[n].y = points[0].y;
    if (fp > 0) {
       set_fill_style(fp);
       XSetFillRule(display_eagle, gc_eagle, EvenOddRule);
       XFillPolygon(display_eagle, w_present_eagle, gc_eagle, points, n+1,
				   Complex, CoordModeOrigin);
       set_fill_style(1);
    }
    else XDrawLines(display_eagle, w_present_eagle, gc_eagle, points, n+1,
				   CoordModeOrigin); 
    XFlush(display_eagle); free(points);
    if( (w_present_eagle == w_first_eagle) && (p_control_eagle == 1) ) {
      fprintf(file_id_eagle, "x_polygon\n");
      fprintf(file_id_eagle, "%d %d %d %d\n",
			      n, line_style_eagle, line_width_eagle, fp);
      for (i = 0; i < n; i++) fprintf(file_id_eagle, "%d %d\n", x[i], y[i]);
    }
}

int x_printf(x, y, va_alist)
    int x, y; va_dcl
{
    va_list args; int length; char string[32768]; char *format;
    va_start(args); 
    format = va_arg(args, char *);
    vsprintf(string, format, args);
    length = strlen(string);
    XDrawString(display_eagle, w_present_eagle, gc_eagle, x, y, string, length);
    XFlush(display_eagle);
    va_end(args);
    if( (w_present_eagle == w_first_eagle) && (p_control_eagle == 1) ) {
      fprintf(file_id_eagle, "x_printf\n");
      fprintf(file_id_eagle, "%d %d %d\n", x, y, font_id_eagle);
      fprintf(file_id_eagle, string); fprintf(file_id_eagle, "\n");
    }
}
