/* eagle5.c in ~/eagle */
#include "eagle.h"

int e_wait(KP, BP, BR, MN, EN, LN, x, y, button, w, key)
    int KP, BP, BR, MN, EN, LN; int *x, *y, *button; Window *w; KeySym *key;
{
    XEvent event; char st[20]; int n_bite; KeySym key1; int type; type = 0;

    while (!type) {
      XNextEvent(display_eagle, &event);
      *w = event.xany.window;

      switch (event.type) {
      case KeyPress:
	if (!KP) break;
        n_bite = XLookupString(&event.xkey, st, 20, &key1, NULL);
        st[n_bite] = 0; if (n_bite > 1) break;
	*x = event.xkey.x; *y = event.xkey.y; *key = key1;
        type = event.type; break;
      case ButtonPress:
	if (!BP) break;
	*x = event.xbutton.x; *y = event.xbutton.y;
	*button = event.xbutton.button; type = event.type; break;
      case ButtonRelease:
	if (!BR) break;
	*x = event.xbutton.x; *y = event.xbutton.y;
	*button = event.xbutton.button; type = event.type; break;
      case MotionNotify:
	if (!MN) break;
	*x = event.xmotion.x; *y = event.xmotion.y;
        type = event.type; break;
      case EnterNotify:
	if (!EN) break;
	*x = event.xcrossing.x; *y = event.xcrossing.y;
        type = event.type; break;
      case LeaveNotify:
	if (!LN) break;
	*x = event.xcrossing.x; *y = event.xcrossing.y;
        type = event.type; break;
      default:
	break;
      }
    }
    p_control_eagle = 0;
    return type;
}

Bool e_nowait(type, x, y, button, w, key)
    int type; int *x, *y, *button; Window *w; KeySym *key;
{
    XEvent event; char st[20]; int n_bite; KeySym key1; Bool occur;

    occur = XCheckTypedEvent(display_eagle, type, &event);
    if (!occur) return False;
    *w = event.xany.window;

    switch (event.type) {
    case KeyPress:
        n_bite = XLookupString(&event.xkey, st, 20, &key1, NULL);
        st[n_bite] = 0; if (n_bite > 1) occur = False;
	*x = event.xkey.x; *y = event.xkey.y; *key = key1; break;
    case ButtonPress:
	*x = event.xbutton.x; *y = event.xbutton.y;
	*button = event.xbutton.button; break;
    case ButtonRelease:
	*x = event.xbutton.x; *y = event.xbutton.y;
	*button = event.xbutton.button; break;
    case MotionNotify:
	*x = event.xmotion.x; *y = event.xmotion.y; break;
    case EnterNotify:
	*x = event.xcrossing.x; *y = event.xcrossing.y; break;
    case LeaveNotify:
	*x = event.xcrossing.x; *y = event.xcrossing.y; break;
    default:
	occur = False; break;
    }
    p_control_eagle = 0;
    return occur;
}

Bool e_nowait_window(w, type, x, y, button, key)
    Window w; int type; int *x, *y, *button; KeySym *key;
{
    XEvent event; char st[20]; int n_bite; KeySym key1; Bool occur;

    occur = XCheckTypedWindowEvent(display_eagle, w, type, &event);
    if (!occur) return False;

    switch (event.type) {
    case KeyPress:
        n_bite = XLookupString(&event.xkey, st, 20, &key1, NULL);
        st[n_bite] = 0; if (n_bite > 1) occur = False;
	*x = event.xkey.x; *y = event.xkey.y; *key = key1; break;
    case ButtonPress:
	*x = event.xbutton.x; *y = event.xbutton.y;
	*button = event.xbutton.button; break;
    case ButtonRelease:
	*x = event.xbutton.x; *y = event.xbutton.y;
	*button = event.xbutton.button; break;
    case MotionNotify:
	*x = event.xmotion.x; *y = event.xmotion.y; break;
    case EnterNotify:
	*x = event.xcrossing.x; *y = event.xcrossing.y; break;
    case LeaveNotify:
	*x = event.xcrossing.x; *y = event.xcrossing.y; break;
    default:
	occur = False; break;
    }
    p_control_eagle = 0;
    return occur;
}

void e_mouse_state(w, x, y, button1, button2, button3)
    Window w; int *x, *y; Bool *button1, *button2, *button3;
{
    Window rt, child; int xr, yr, xw, yw, XQ; unsigned int buttons;
    XQ = XQueryPointer(display_eagle, w, &rt, &child, &xr, &yr,
		       &xw, &yw, &buttons);
    *x = xw; *y = yw;                   *button1 = (buttons & Button1Mask);
    *button2 = (buttons & Button2Mask); *button3 = (buttons & Button3Mask);
    p_control_eagle = 0;
}
