/*
 * The Runge-Kutta Method for N variables
 */
void Runge_Kutta(N, time, x, dt, k1, k2, k3, k4, w)
int N; double time, dt;
double x[], k1[], k2[], k3[], k4[], w[];
{
   int i; extern void RKfunc();
   RKfunc(N, time, x, k1);
   for (i = 0; i < N; i++) w[i] = x[i] + dt*k1[i]/2.0;
   RKfunc(N, time+dt/2.0, w, k2);
   for (i = 0; i < N; i++) w[i] = x[i] + dt*k2[i]/2.0;
   RKfunc(N, time+dt/2.0, w, k3);
   for (i = 0; i < N; i++) w[i] = x[i] + dt*k3[i];
   RKfunc(N, time+dt, w, k4);
   for (i = 0; i < N; i++) x[i] = x[i] + dt*(k1[i]+2.*k2[i]+2.*k3[i]+k4[i])/6.;
}
