/* sample63.c */
#include "../eagle/eagle.h"
#define M 803
Window w0, w1, w2;
X_real x[M];
unsigned long ryukoku_grey2;
unsigned long ryukoku_ohmiya, ryukoku_fukakusa, ryukoku_seta;

void set_matrix(A, B, C, D, E, dd, N)
    X_real A[], B[], C[], D[], E[]; X_real dd; int N;
{
    int i;
    for (i=0; i<N; i++)
    {  A[i] = 1.0+2.0*dd; B[i] = -dd; C[i] = -dd; D[i] = 0.0; E[i] = 0.0; }
    B[N-1] = 0.0; B[N-2] = 0.0; C[N-1] = 0.0; C[0] = 0.0;
    D[0] = -dd;   D[N-2] = -dd; E[0] = -dd;   E[N-2] = -dd;
}

void display(u, v, N)
    X_real u[], v[]; int N;
{
    u[N] = u[0]; v[N] = v[0];
    u[N+1] = 0.0; u[N+2] = 0.0; v[N+1] = 0.0; v[N+2] = 0.0;
    w_select(w1); w_clear(); set_line_width(3);
    set_foreground(ryukoku_fukakusa); m_graph(N, 0.0, 1.0, v);
    set_foreground(ryukoku_seta); m_graph(N, 0.0, 1.0, u);
    set_line_width(1); m_line(0.0, 0.0, 1.0, 0.0);

    w_select(w2); w_clear(); set_line_width(3);
    set_foreground(ryukoku_fukakusa); m_polygon(N+3, x, v, 15);
    m_graph(N, 0.0, 1.0, v); 
    set_foreground(ryukoku_seta); m_polygon(N+3, x, u, 15);
    m_graph(N, 0.0, 1.0, u);
    set_line_width(1); m_line(0.0, 0.0, 1.0, 0.0);
}

main()
{
    int N, disp_interval, num_disp, ndisp, nnum, i;
    X_real aa, epsilon, gamma, L, dx, dt, dd, uu, vv, umin, umax;
    X_real u[M], v[M], Au[M], Bu[M], Cu[M], Du[M], Eu[M];
    extern void LUPdecomp(), LUPsolve();

    aa = 0.25; epsilon = 0.002; gamma = 6.0; L = 400.0;
    N = M-3; dx = L/N; dt = 0.1;
    disp_interval = 50; num_disp = 180;
    dd = dt/dx/dx;
    set_matrix(Au, Bu, Cu, Du, Eu, dd, N);
    LUPdecomp(Au, Bu, Cu, Du, Eu, N);

    for (i = 0; i<N; i++) { u[i] = 0.0; v[i] = 0.0; }
    for (i = 600; i<640; i++) u[i] = 0.9;

    w0 = x_init(1000, 800, "Eagle_data");
    w1 = w_open(w0, 10,  10, 980, 380);
    w2 = w_open(w0, 10, 410, 980, 380);
    ryukoku_grey2    = set_color(180, 180, 180);
    ryukoku_ohmiya   = set_color(120,   0, 120);
    ryukoku_fukakusa = set_color( 20, 160,  20);
    ryukoku_seta     = set_color( 70,  70, 220);
    set_background(ryukoku_ohmiya); w_clear();
    w_select(w1); set_background(ryukoku_grey2); w_clear();
    w_select(w2); set_background(ryukoku_grey2); w_clear();
    umin = -0.2; umax = 1.0;
    m_trans_def(0.0, umin, 1.0, umax, 0, 0, 980, 380);
    for (i = 0; i<=N; i++) x[i] = i*1.0/N;
    x[N+1] = 1.0; x[N+2] = 0.0;

    display(u, v, N); sleep(3);

    for (nnum=0; nnum<num_disp; nnum++) {
	for (ndisp=0; ndisp<disp_interval; ndisp++) {
	    for (i=0; i<N; i++) {
	      uu = u[i]; vv = v[i];
	      u[i] = uu + dt*(uu*(1.0-uu)*(uu-aa)-vv);
	      v[i] = vv + dt*epsilon*(uu-gamma*vv);
	    }
	    LUPsolve(Au, Bu, Cu, Du, Eu, u, N);
	}
        display(u, v, N);
    }
    sleep(3);

    w_close(w1); w_close(w2); w_close(w0);
    x_term();
}
