/* sample91.c */
#include "../eagle/eagle.h"
#define Mmax (2000)

void solve(x0, y0, button, dt, M, xx, yy, xmax, ymax)
    X_real x0, y0, dt, xmax, ymax; int button, M;
    X_real xx[], yy[];
{
    X_real x[2], k1[2], k2[2], k3[2], k4[2], work[2];
    int K, j, i;
    extern void Runge_Kutta();

    if (button == 1) { dt = -dt; button = 3;}

    switch (button) {

    case 3:
       xx[0] = x0; yy[0] = y0; x[0] = x0; x[1] = y0;
       for (j=1; j<=M; j++) {
	  Runge_Kutta(2, 0.0, x, dt, k1, k2, k3, k4, work);
	  xx[j] = x[0]; yy[j] = x[1];
	  if ((fabs(x[0])>xmax)||(fabs(x[1])>ymax)) {
	     for (i=j; i<=M; i++) { xx[i] = xx[j-1]; yy[i] = yy[j-1]; }
	     j = M+1;
          }
       }
       break;

    case 2:
       K = M/2; xx[K] = x0; yy[K] = y0; x[0] = x0; x[1] = y0;
       for (j=K+1; j<=M; j++) {
	  Runge_Kutta(2, 0.0, x, dt, k1, k2, k3, k4, work);
	  xx[j] = x[0]; yy[j] = x[1];
	  if ((fabs(x[0])>xmax)||(fabs(x[1])>ymax)) {
	     for (i=j; i<=M; i++) { xx[i] = xx[j-1]; yy[i] = yy[j-1]; }
	     j = M+1;
          }
       }
       dt = -dt; x[0] = x0; x[1] = y0;
       for (j=K-1; j>=0; j--) {
	  Runge_Kutta(2, 0.0, x, dt, k1, k2, k3, k4, work);
	  xx[j] = x[0]; yy[j] = x[1];
	  if ((fabs(x[0])>xmax)||(fabs(x[1])>ymax)) {
	     for (i=j; i>=0; i--) { xx[i] = xx[j+1]; yy[i] = yy[j+1]; }
	     j = -1;
          }
       }
       break;

    }
}

void solve_draw(x, y, button, dt, Mold, M,
	        old_x, old_y, new_x, new_y, xmax, ymax)
    X_real x, y, dt, xmax, ymax; int button, Mold, M;
    X_real old_x[], old_y[], new_x[], new_y[];
{
    int j;
    extern void solve();
    solve(x, y, button, dt, M, new_x, new_y, xmax, ymax);
    m_lines(Mold, old_x, old_y); m_lines(M, new_x, new_y);
    for (j=0; j<=M; j++)
       { old_x[j] = new_x[j]; old_y[j] = new_y[j]; }
}

void change_dt(dt, dt_change, w0, w1, key)
     X_real *dt, dt_change; Window w0, w1; KeySym key;
{
     if (key == XK_i) *dt = (*dt)*dt_change;
     if (key == XK_d) *dt = (*dt)/dt_change;
     w_select(w1); w_clear(); x_printf(0, 30, "dt = %lf", *dt);
     w_select(w0);
}

void  change_M(M, M_change, w0, w1, key)
     int *M; X_real M_change; Window w0, w1; KeySym key;
{
     if (key == XK_l) *M = (*M)*M_change;
     if (key == XK_s) *M = (*M)/M_change;
     if (*M > Mmax - 1) *M = Mmax - 1; if (*M < 10) *M = 10;
     w_select(w1); w_clear(); x_printf(0, 30, " M = %d", *M);
     w_select(w0);
}

main()
{
    Window      w0, w1, w2, w;
    KeySym      key;
    X_real      new_x[Mmax], new_y[Mmax], old_x[Mmax], old_y[Mmax];
    X_real      x, y, xmax, ymax, dt;
    X_real      dt_change, M_change;
    int         wx, wy, M, Mold, j;
    int         BP, BR, KP, MN, button, etype, xint, yint;
    extern void solve_draw(), solve();

    xmax = 5.0; ymax = xmax;
    dt = 0.1; M = 100; dt_change = 1.1; M_change = 1.1;

    wx = 620; wy = 600;
    w0 = x_init(wx, wy+50, "Eagle_data");
    w1 = w_open(w0,  20, wy+10, 270, 35);
    w2 = w_open(w0, 320, wy+10, 270, 35);
    m_trans_def(-xmax, -ymax, xmax, ymax, 20, 20, wx-40, wy-20);
    p_control_eagle = 1; m_box(-xmax, -ymax, xmax, ymax, 0);
    m_line(-xmax, 0.0, xmax, 0.0); m_line(0.0, -ymax, 0.0, ymax);
    x_printf(20, 18, "Solution Orbits of van der Pol Eq.");

    w_select(w1); w_clear(); x_printf(0, 30, "dt = %lf", dt);
    w_select(w2); w_clear(); x_printf(0, 30, " M = %d", M);
    w_select(w0); KP = 1; BP = 1; BR = 1; MN = 1;

    while (1) {

      etype = e_wait(KP, BP, 0, 0, 0, 0, &xint, &yint, &button, &w, &key);
      m_trans_x_to_m(xint, yint, &x, &y);
      set_draw_mode(1); p_control_eagle = 0;

      if ((etype==KeyPress)&&(key == XK_Escape)) break;

      if ((etype==KeyPress)&&((key == XK_i)||(key == XK_d)))
	  change_dt(&dt, dt_change, w0, w1, key);

      if ((etype==KeyPress)&&((key == XK_l)||(key == XK_s)))
	  change_M(&M, M_change, w0, w2, key);

      if (etype == ButtonPress) {
	solve(x, y, button, dt, M, new_x, new_y, xmax, ymax);
	m_lines(M, new_x, new_y);
	for (j=0; j<=M; j++)
	  { old_x[j] = new_x[j]; old_y[j] = new_y[j]; }
	
	while (1) {
	 
          etype = e_wait(KP, 0, BR, MN, 0, 0, &xint, &yint, &button, &w, &key);
          m_trans_x_to_m(xint, yint, &x, &y);

	  if (etype==ButtonRelease) { m_lines(M, old_x, old_y); break; }

          if ((etype==KeyPress)&&((key == XK_i)||(key == XK_d))) {
	      change_dt(&dt, dt_change, w0, w1, key);
	      solve_draw(x, y, button, dt, M, M,
			 old_x, old_y, new_x, new_y, xmax, ymax);
          }

          if ((etype==KeyPress)&&((key == XK_l)||(key == XK_s))) {
	      Mold = M; change_M(&M, M_change, w0, w2, key);
	      solve_draw(x, y, button, dt, Mold, M,
			 old_x, old_y, new_x, new_y, xmax, ymax);
	  }

          if ((etype==KeyPress)&&(key == XK_f)) {
	      m_lines(M, old_x, old_y); set_draw_mode(0); p_control_eagle = 1;
	      m_lines(M, new_x, new_y); break;
	  }
         
	  if (etype == MotionNotify)
	      solve_draw(x, y, button, dt, M, M,
	         	 old_x, old_y, new_x, new_y, xmax, ymax);
        }
      }
    }

    w_close(w1); w_close(w2); w_close(w0); x_term();
}

